; ----------------------------------------------------------------------------
; txtfmt(a0: string, a1: data, a3: output)
; ----------------------------------------------------------------------------
txtfmt:
	move.l	a6,-(a7)
	move.l	4.w,a6
	lea	.put_ch(pc),a2
	jsr	-522(a6)		; RawDoFmt(a0:FormatString, a1:DataStream, a2:PutChProc, a3:PutChData)
	move.l	(a7)+,a6
	rts
.put_ch	tst.b	d0			; do not copy last 0 byte into dst
	bne.b	.do_put
	rts
.do_put	move.b	d0,(a3)+
	rts
txtfmt_including_trailing_0:
	move.l	a6,-(a7)
	move.l	4.w,a6
	lea	.put_ch(pc),a2
	jsr	-522(a6)		; RawDoFmt(a0:FormatString, a1:DataStream, a2:PutChProc, a3:PutChData)
	move.l	(a7)+,a6
	rts
.put_ch	move.b	d0,(a3)+
	rts

; ----------------------------------------------------------------------------
; d0 = nextrandom(d2: max exclusive)
; ----------------------------------------------------------------------------
nextrandom:
	bsr.b	random
	and.l	#$7fff,d0
	divu	d2,d0
	swap	d0		; random % max
	rts
; ----------------------------------------------------------------------------
; random()
; ----------------------------------------------------------------------------
random:
	movem.w	d1/d2,-(a7)
	move.l	_seed(a5),d0
	btst	#1,d0
	sne	d1
	btst 	#5,d0
	sne	d2
	eor.b	d2,d1
	btst	#6,d0
	sne	d2
	eor.b	d2,d1
	btst	#31,d0
	sne	d2
	eor.b	d2,d1
	add.b	d1,d1
	addx.l	d0,d0
	move.l	d0,_seed(a5)
	movem.w	(a7)+,d2/d1
	rts
init_random:
	moveq	#0,d0
	move.b	$bfd800,d0
	lsl.l	#8,d0
	move.b	$bfd601,d0
	lsl.l	#8,d0
	move.b	$bfd901,d0
	move.l	d0,_seed(a5)
	rts
randomize_seed:
	move.l	_seed(a5),d0
	add.w	_ticks(a5),d0
	swap	d0
	add.w	_oldhorizcnt(a5),d0
	move.l	d0,_seed(a5)
	rts
