NUM_DEBUG_STRINGS=32
DEBUG_STRING_LEN=64
debug_log_renderer:
	move.l	#debugbuffer,_txt_page(a5)
	cmp.b	#VK_F7,_key(a5)
	beq.b	.doreturn
	cmp.b	#VK_F8,_key(a5)
	beq.b	.dopause
	cmp.b	#VK_X,_key(a5)
	beq.b	.doreturn
	bra.b	.noreturn
	rts
.doreturn
	move.l	_stashed_renderer(a5),_txt_renderer(a5)
	clr.w	_debug_log_pause(a5)
	rts
.dopause
	bchg	#0,_debug_log_pause+1(a5)
.noreturn
	lea	debugbuffer,a1
	bsr	clear_buffer
	lea	debug_title,a0
	lea	fmt_args,a1
	move.w	_ticks(a5),(a1)
	lea	debugbuffer,a3
	bsr	txtfmt			; txtfmt(a0: string, a1: data, a3: output)
	; log output
	move.w	current_debug_string_index,d7
	add.w	#32,d7
	lea	debugbuffer+40*23,a1
	move.w	#22-1,d6
.lines
	subq.w	#1,d7
	move.w	d7,d0
	and.w	#31,d0
	mulu	#DEBUG_STRING_LEN,d0
	lea	debug_strings,a0
	add.w	d0,a0
	move.l	a1,a2
.cp	move.b	(a0)+,d0
	beq.b	.ldone
	move.b	d0,(a2)+
	bra.b	.cp
.ldone
	sub.w	#40,a1
	dbf	d6,.lines
	rts

debug_title:
	dc.b	'        F8 pause F7 return  %5d',0
	even

debug_append_latest_debug_string:
	tst.w	_debug_log_pause(a5)
	beq.b	.no_pause
	rts
.no_pause
	clr.b	latest_debug_string+36-1	; truncate
	lea	debug_strings,a3
	move.w	current_debug_string_index,d0
	mulu	#DEBUG_STRING_LEN,d0
	add.w	d0,a3

	; next in ringbuffer
	move.w	current_debug_string_index,d0
	addq.w	#1,d0
	and.w	#31,d0
	move.w	d0,current_debug_string_index

	lea	debug_log_fmt,a0
	lea	debug_log_fmt_data,a1
	move.w	_ticks(a5),d0
	and.w	#$fff,d0
	move.w	d0,(a1)
	move.l	#latest_debug_string,2(a1)
	bsr	txtfmt_including_trailing_0	; txtfmt(a0: string, a1: data, a3: output)

	lea	latest_debug_string,a1
	rept 10
	clr.l	(a1)+
	endr
	rts

debug_log_fmt:
	dc.b	'%03x %s',0
	even
debug_log_fmt_data:
	dc.l	0,0,0,0
latest_debug_string:
	ds.b	128
current_debug_string_index:
	dc.w	0
	dc.b	'DSTR'
debug_strings:
	ds.b	DEBUG_STRING_LEN*NUM_DEBUG_STRINGS
;	ds.b	2000

